#include <STDLIB.H>
#include <STDIO.H>

#define CHUNKSIZE 4096


long getFilesize(FILE* AStream) {
   long curpos;
   long length;

   curpos = ftell(AStream);
   fseek(AStream, 0L, SEEK_END);
   length = ftell(AStream);
   fseek(AStream, curpos, SEEK_SET);
   return length;
}


int main(int argc, char* argv[]) {
  FILE* inputFile;
  FILE* outputFile;
  char  buf1[CHUNKSIZE];
  char* buf2;
  long l;

  if (argc < 4) {
    printf("delbytes by Frenkel, 22-Aug-2008.\n");
    printf("Usage: delbytes INPUTFILE OUTPUTFILE NUMBEROFBYTESTOREMOVEFROMSTARTOFINPUTFILE\n");
    return -1;
  }

  inputFile = fopen(argv[1], "rb");
  if (inputFile == NULL) {
    printf("delbytes by Frenkel, 22-Aug-2008.\n");
    printf("Can't find %s!\n", argv[1]);
    return -1;
  }

  outputFile = fopen(argv[2], "wb");
  if (outputFile == NULL) {
    printf("delbytes by Frenkel, 22-Aug-2008.\n");
    printf("Can't create %s!\n", argv[2]);
    return -1;
  }

  fseek(inputFile, atol(argv[3]), SEEK_SET);

  l = getFilesize(inputFile) - atol(argv[3]);
  while (CHUNKSIZE <= l) {
    fread(buf1,  CHUNKSIZE, 1, inputFile);
    fwrite(buf1, CHUNKSIZE, 1, outputFile);
    // { CHUNKSIZE <= l }
    l -= CHUNKSIZE;
  }
  // { l < CHUNKSIZE }
  buf2 = (char*) malloc((int) l);
  if (buf2 == NULL) {
    printf("delbytes by Frenkel, 22-Aug-2008.\n");
    printf("Not enough memory available!\n");
    return -1;
  }
  fread(buf2,  (int) l, 1, inputFile);
  fwrite(buf2, (int) l, 1, outputFile);

  fclose(inputFile);
  fclose(outputFile);
  free(buf2);
  return 0;
}