#include <STDIO.H>
#include <DOS.H>


void setScreenMode(void) {
  int i;
  static const unsigned char pal[] =
  {  0,   0,   0,
     0, 168, 168,
   252,  84, 252,
   252, 252, 252,
     0,   0, 168,
    84, 252,  84,
   252,  84,  84,
   252, 252,  84,
    84,  84,  84,
    84,  84, 252,
   168,   0, 168,
    84, 252, 252,
   168,  84,   0,
     0, 168,   0,
   168,   0,   0,
   168, 168, 168
  };

  asm {
    mov ax, 0x0013;
    int 0x10;
  }

  //set palette
  outportb(0x3C8, 0);
  for (i = 0; i < 16*3; i++) {
    outportb(0x3C9, pal[i] >> 2);
  }
}

int main(int argc, char* argv[]) {
  int x, y;
  FILE* imageFile;
  char line[320];


  if (argc < 2) {
    printf("Mega Man III full screen image viewer by Frenkel, 23-Aug-2008.\n");
    printf("Usage: tiles DECOMPRESSEDFULLSCREENIMAGEFILE\n");
    return -1;
  }

  imageFile = fopen(argv[1], "rb");
  if (imageFile == NULL) {
    printf("Mega Man III full screen image viewer by Frenkel, 23-Aug-2008.\n");
    printf("Can't find %s!\n", argv[1]);
    return -1;
  }

  setScreenMode();

  for (y = 0; y < 200; y++) {
    fread(line, 320, 1, imageFile);
    for (x = 0; x < 320; x++) {
      pokeb(0xA000, y*320+x, line[x]);
    }
  }

  fclose(imageFile);

  asm {
    xor ah, ah;
    int 0x16;

    mov ax, 0x0003;
    int 0x10;
  }

  printf("Mega Man III full screen image viewer by Frenkel, 23-Aug-2008.\n");
  return 0;
}