#include <STDIO.H>
#include <STDLIB.H>
#include <STRING.H>
#include <DOS.H>
#include <CONIO.H>

//#define MAPNAME "OILRIG" //1 Bit man
//#define MAPNAME "OCEAN"  //2 Shark man
//#define MAPNAME "TANKER" //3 Wave man
//#define MAPNAME "REFINE" //4 Oil man
//#define MAPNAME "SEWER"  //5 Blade man
//#define MAPNAME "CITY"   //6 Torch man
//#define MAPNAME "CASTLE" //7 CRORQ, Dr Wily

char* FMapName;
unsigned char* FMapScene;
int FMapWidth,    FMapHeight;
int FScreenWidth, FScreenHeight;
int FWindowWidth, FWindowHeight;
unsigned char* FZBuffer;
int FEnemyCount;
unsigned char* FEnemyData;
int FPlayerPosX, FPlayerPosY;

void setPixel(int x, int y, unsigned char c) {
  if ((0 <= x) && (x < FScreenWidth) && (0 <= y) && (y < FScreenHeight)) {
    asm {
      mov ah, 0x0C;
      mov al, c;
      xor bh, bh;
      mov cx, x;
      mov dx, y;
      int 0x10;
    }
  }
}

void setPixelZ(int x, int y, unsigned char c) {
  if ((0 <= x) && (x < FScreenWidth) && (0 <= y) && (y < FScreenHeight)) {
    if ((FZBuffer[y * (FScreenWidth >> 3) + (x >> 3)] >> (7^(x & 7))) & 1) {
      setPixel(x, y, c);
    }
  }
}


void drawTile(int AX, int AY, unsigned char AN) {
  FILE* blockFile;
  char blockFilename[12];
  char block[256];
  char mask[32];
  int x, y;
  int i;

  strcpy(blockFilename, FMapName);

  strcat(blockFilename, ".BLK");
  blockFile = fopen(blockFilename, "rb");
  if (blockFile == NULL) {
    asm {
      mov ax, 3;
      int 0x10;
    }
    printf("Can't open tile file.\n");
    exit(EXIT_FAILURE);
  }

  fseek(blockFile, (long) 16 * 16 * AN, SEEK_SET);
  fread(block, 16*16, 1, blockFile);
  fseek(blockFile, (long) 256*256+ 32*AN, SEEK_SET);
  fread(mask, 32, 1, blockFile);
  fclose(blockFile);

  i = 0;
  for (y = 0; y < 16; y++) {
    for (x = 0; x < 16; x++) {
      setPixel(x + AX * 16, y + AY * 16, block[i]);
      i++;
    }
  }

  i = 0;
  for (y = 0; y < 16; y++) {
    for (x = 0; x < 2; x++) {
      FZBuffer[(y + AY * 16) * 80 + x + AX + AX] = mask[i];
      i++;
    }
  }
}


void setScreenMode(void) {
  int i;
  static const unsigned char pal[] =
  {  0,   0,   0,
     0, 168, 168,
   252,  84, 252,
   252, 252, 252,
     0,   0, 168,
    84, 252,  84,
   252,  84,  84,
   252, 252,  84,
    84,  84,  84,
    84,  84, 252,
   168,   0, 168,
    84, 252, 252,
   168,  84,   0,
     0, 168,   0,
   168,   0,   0,
   168, 168, 168
  };

  asm {
    mov ax, 0x0012;
    int 0x10;
  }
  FScreenWidth  = 640;
  FScreenHeight = 480;

  //set palette
  for (i = 0; i < 8; i++) {
    if (i == 6) {
      outportb(0x3C8, 20);
    }
    else {
      outportb(0x3C8, i);
    }
    outportb(0x3C9, pal[i*3+0] >> 2);
    outportb(0x3C9, pal[i*3+1] >> 2);
    outportb(0x3C9, pal[i*3+2] >> 2);
  }
  for (i = 8; i < 16; i++) {
    outportb(0x3C8, i + 48);
    outportb(0x3C9, pal[i*3+0] >> 2);
    outportb(0x3C9, pal[i*3+1] >> 2);
    outportb(0x3C9, pal[i*3+2] >> 2);
  }

  FZBuffer = (unsigned char*) malloc((FScreenWidth>>3)*FScreenHeight);
  if (FZBuffer == NULL) {
    asm {
      mov ax, 3;
      int 0x10;
    }
    printf("Not enough memory available for z-buffer.\n");
    exit(EXIT_FAILURE);
  }
}



void loadMapScene(void) {
  FILE* mapFile;
  char mapFilename[13];

  strcpy(mapFilename, FMapName);

  if      (stricmp(FMapName, "CASTLE") == 0 ) { FMapWidth = 190; FMapHeight = 168; }
  else if (stricmp(FMapName, "CITY")   == 0 ) { FMapWidth = 300; FMapHeight =  86; }
  else if (stricmp(FMapName, "OCEAN")  == 0 ) { FMapWidth = 320; FMapHeight =  96; }
  else if (stricmp(FMapName, "OILRIG") == 0 ) { FMapWidth = 188; FMapHeight =  98; }
  else if (stricmp(FMapName, "REFINE") == 0 ) { FMapWidth = 196; FMapHeight =  99; }
  else if (stricmp(FMapName, "SEWER")  == 0 ) { FMapWidth = 315; FMapHeight =  78; }
  else if (stricmp(FMapName, "TANKER") == 0 ) { FMapWidth = 235; FMapHeight = 104; }
  else {
    printf("UNKNOWN MAP NAME %s!\n", FMapName);
    exit(EXIT_FAILURE);
  }

  FMapScene = (unsigned char*) malloc(FMapWidth * FMapHeight);
  if (FMapScene == NULL) {
    printf("Not enough memory available for map scene data.\n");
    exit(EXIT_FAILURE);
  }

  strcat(mapFilename, ".SCE");
  printf("Loading %s...\n", mapFilename);

  mapFile = fopen(mapFilename, "rb");
  if (mapFile == NULL) {
    printf("Can't open map scene file %s.\n", mapFilename);
    exit(EXIT_FAILURE);
  }

  fread(FMapScene, FMapWidth * FMapHeight, 1, mapFile);

  fread(&FPlayerPosX, 2, 1, mapFile);
  fread(&FPlayerPosY, 2, 1, mapFile);
  fread(&FEnemyCount, 2, 1, mapFile);

  FEnemyData = (unsigned char*) malloc(FEnemyCount * 16);
  if (FEnemyData == NULL) {
    printf("Not enough memory available for enemy data.\n");
    exit(EXIT_FAILURE);
  }

  fread(FEnemyData, FEnemyCount, 16, mapFile);

  fclose(mapFile);
}


void drawSprite(int AX, int AY, int AS, char AFlipped) {
  FILE* spriteFile;
  unsigned char temp[14];
  unsigned char imageWidth, imageHeight;
  unsigned char byte;
  unsigned char mask;
  int x, y;
  int pel;
  unsigned char p;
  int dx, dy;
  int m;
  int s;
  char* spriteFilename;

  switch (AS) {
    case 0x00: dx =  -8; dy =  -5; m = -1; s = 0; spriteFilename = "ANENMY.SPR";   break;
    case 0x01: dx =   0; dy =   0; m =  0; s = 0; spriteFilename = "BEE.SPR";      break;
    case 0x02: dx =  -8; dy =  -4; m = -1; s = 0; spriteFilename = "CLAM.SPR";     break;
    case 0x03: dx =   0; dy = -14; m = -1; s = 0; spriteFilename = "FISHMAN.SPR";  break;
    case 0x04: dx =   0; dy =  -6; m = -1; s = 0; spriteFilename = "FLYTRP.SPR";   break;
    case 0x05: return; //spriteFilename = "FRKLFT.SPR" ?
    case 0x06: dx =   0; dy = -16; m = -1; s = 1; spriteFilename = "GTRDCK.SPR";   break;
    case 0x07: dx =  -8; dy = -16; m = -1; s = 0; spriteFilename = "GUNNER.SPR";   break; //Sniper Joe
    case 0x08: dx =  -8; dy =   3; m = -1; s = 0; spriteFilename = "HELMET.SPR";   break; //(Neo?) Met
    case 0x09: dx =  -4; dy =   1; m = -1; s = 0; spriteFilename = "LAZER.SPR";    break;
    case 0x0A: dx =   0; dy =   0; m = -1; s = 0; spriteFilename = "MSQITO.SPR";   break;
    case 0x0B: dx=(AFlipped?-18:0);dy=0;m=-1;s=0; spriteFilename = "NAUTLS.SPR";   break;
    case 0x0C: dx=(AFlipped?-4:-12);dy=2;m=-1;s=0;spriteFilename = "ROCK-H.SPR";   break;
    case 0x0D: dx=(AFlipped?-8:0);dy=2;m=-1;s= 0; spriteFilename = "ROCK-V.SPR";   break;
    case 0x0E: dx =   0; dy = -15; m = -1; s = 0; spriteFilename = "ROSE.SPR";     break;
    case 0x0F: dx =   0; dy =   0; m = -1; s = 0; spriteFilename = "SNLBAT.SPR";   break;
    case 0x10: dx =   0; dy = -16; m = -1; s = 0; spriteFilename = "SNPDRG.SPR";   break;
    case 0x11: dx =   0; dy = -12; m = -1; s = 0; spriteFilename = "SPDSNK.SPR";   break;
    case 0x12: dx =   0; dy = -16; m = -1; s = 0; spriteFilename = "TOXMAN.SPR";   break;
    case 0x13: dx =  -4; dy =  -1; m = -1; s = 0; spriteFilename = "WALLGN.SPR";   break;
    case 0x14: dx =   0; dy = -12; m = -1; s = 0; spriteFilename = "LG-WEED.SPR";  break;
    case 0x15: dx =   0; dy =  -7; m = -1; s = 0; spriteFilename = "SM-WEED.SPR";  break;
    case 0x16: dx =   0; dy =0/*3*/; m =  0; s = 1; spriteFilename = "PILLS.SPR";  break;
    case 0x17: dx =   0; dy =0/*18*/; m =  0; s = 0; spriteFilename = "PILLS.SPR"; break;
    case 0x18: dx =   0; dy =0/*3*/; m =  0; s = 2; spriteFilename = "PILLS.SPR";  break;
    case 0x19: dx =  -4; dy = -16; m = -1; s = 0; spriteFilename = "BOSDOR.SPR";   break;
    case 0x1A: dx = -16; dy = -16; m = -1; s = 0; spriteFilename = "PISTON.SPR";   break;
    case 0x1B: dx =  -4; dy = -16; m = -1; s = 0; spriteFilename = "BOSDOR.SPR";   break;
    case 0x1C: dx =   0; dy =   0; m =  0; s = 6; spriteFilename = "PILLS.SPR";    break;

    case 0x81: dx = -20; dy = -30; m = -1; s = 3; spriteFilename = "BOSS1.SPR";    break;
    case 0x82: dx =  -8; dy = -30; m = -1; s = 3; spriteFilename = "BOSS2.SPR";    break;
    case 0x83: dx=(AFlipped?-4:-12);dy=-21;m=-1;s=3;spriteFilename="BOSS3.SPR";    break;
    case 0x84: dx = -12; dy = -27; m = -1; s = 3; spriteFilename = "BOSS4.SPR";    break;
    case 0x85: dx = -12; dy = -23; m = -1; s = 3; spriteFilename = "BOSS5.SPR";    break;
    case 0x86: dx = -20; dy = -23; m = -1; s = 3; spriteFilename = "BOSS6.SPR";    break;
    case 0x87: dx = -24; dy = -39; m = -1; s = 0; spriteFilename = "DOCBOT.SPR";   break;
    case 0x88: dx = -20; dy =  -9; m = -1; s = 0; spriteFilename = "DOCWILLE.SPR"; break;

    case   -2:
      if (stricmp(FMapName, "OCEAN")  == 0 ) {
	dx = -24; dy =   0; m = -1; s = 18; spriteFilename = "MEGAMENV.SPR";
      }
      else {
	dx = -16; dy = -16; m = -1; s =  0; spriteFilename = "MEGAMENV.SPR";
      }
      break;

    default:   dx =   0; dy =   0; m =  0; s = 0; spriteFilename = "MEGAMENV.SPR"; break;
  }
  spriteFile = fopen(spriteFilename, "rb");
  if (spriteFile == NULL) {
    asm {
      mov ax, 3;
      int 0x10;
    }
    printf("Can't open sprite file %s.\n", spriteFilename);
    exit(EXIT_FAILURE);
  }

  fread(temp, 14, 1, spriteFile);
  imageWidth  = temp[12];
  imageHeight = temp[13];
  for (x = 0; x < s; x++) {
    fseek(spriteFile, (long) imageHeight * imageWidth * 9, SEEK_CUR);
    fread(temp, 14, 1, spriteFile);
    imageWidth  = temp[12];
    imageHeight = temp[13];
  }
  if (AFlipped) {
    for (y = 0; y < imageHeight; y++) {
      for (pel = imageWidth - 1; 0 <= pel; pel--) {
	fread(&mask, 1, 1, spriteFile);
	p = 128;
	for (x = 7; 0 <= x; x--) {
	  fread(&byte, 1, 1, spriteFile);
	  if (mask & p) {
	    if (m) {
	      setPixelZ(AX * 16 + x + pel * 8 + dx, AY * 16 + y + dy, byte);
	    }
	    else {
	      setPixel(AX * 16 + x + pel * 8 + dx, AY * 16 + y + dy, byte);
	    }
	  }
	  p = p >> 1;
	}
      }
    }
  }
  else {
    for (y = 0; y < imageHeight; y++) {
      for (pel = 0; pel < imageWidth; pel++) {
	fread(&mask, 1, 1, spriteFile);
	p = 128;
	for (x = 0; x < 8; x++) {
	  fread(&byte, 1, 1, spriteFile);
	  if (mask & p) {
	    if (m) {
	      setPixelZ(AX * 16 + x + pel * 8 + dx, AY * 16 + y + dy, byte);
	    }
	    else {
	      setPixel(AX * 16 + x + pel * 8 + dx, AY * 16 + y + dy, byte);
	    }
	  }
	  p = p >> 1;
	}
      }
    }
  }
  fclose(spriteFile);
}


void drawWindow(int AX, int AY) {
  int x, y;
  int i;
  int s;
  int bossnr;

  for (y = 0; y < FWindowHeight; y++) {
    for (x = 0; x < FWindowWidth; x++) {
      drawTile(x, y, FMapScene[(y+AY)*FMapWidth+x+AX]);
    }
  }

  if      (stricmp(FMapName, "OILRIG") == 0 ) { bossnr = 1; }
  else if (stricmp(FMapName, "OCEAN")  == 0 ) { bossnr = 2; }
  else if (stricmp(FMapName, "TANKER") == 0 ) { bossnr = 3; }
  else if (stricmp(FMapName, "REFINE") == 0 ) { bossnr = 4; }
  else if (stricmp(FMapName, "SEWER")  == 0 ) { bossnr = 5; }
  else if (stricmp(FMapName, "CITY")   == 0 ) { bossnr = 6; }
  else if (stricmp(FMapName, "CASTLE") == 0 ) { bossnr = 1; }
  else {
    asm {
      mov ax, 3;
      int 0x10;
    }
    printf("UNKNOWN MAP NAME %s!\n", FMapName);
    exit(EXIT_FAILURE);
  }

  drawSprite(FPlayerPosX - AX, FPlayerPosY - AY, -2, 0);
  for (i = 0; i < FEnemyCount; i++) {
    x = FEnemyData[i*16+4]+FEnemyData[i*16+5]*256;
    y = FEnemyData[i*16+6]+FEnemyData[i*16+7]*256;
    s = FEnemyData[i*16+0]+FEnemyData[i*16+1]*256;
    drawSprite(x - AX, y - AY, s, FEnemyData[i*16+2]);

    if (s == 0x19) {
      x = FEnemyData[i*16+10]+FEnemyData[i*16+11]*256;
      y = FEnemyData[i*16+14]+FEnemyData[i*16+15]*256;
      drawSprite(x - AX, y - AY, 0x80 + bossnr, !FEnemyData[i*16+2]);
      bossnr++;
    }
  }
}


int main(int argc, char* argv[]) {
  int x, y;
  int quit;
  int c, extended;

  if (argc < 2) {
    printf("Mega Man III level viewer by Frenkel, 23-Aug-2008.\n");
    printf("To use this level viewer type one of the following commands:\n");
    printf("MM3MAP CASTLE\n");
    printf("MM3MAP CITY\n");
    printf("MM3MAP OCEAN\n");
    printf("MM3MAP OILRIG\n");
    printf("MM3MAP REFINE\n");
    printf("MM3MAP SEWER\n");
    printf("MM3MAP TANKER\n");
    return -1;
  }
  FMapName = argv[1];

  loadMapScene();

  setScreenMode();

  FWindowWidth =  min(FMapWidth,  FScreenWidth  >> 4);
  FWindowHeight = min(FMapHeight, FScreenHeight >> 4);

  x = 0;
  y = 0;
  quit = 0;
  while (!quit) {
    drawWindow(x, y);

    c = getch();
    extended = 0;
    if (!c) {
      extended = getch();
    }

    if ((c == 27) || (c == 'q') || (c == 'Q')) {
      quit = -1;
    }
    else if (!c && (extended == 'K')) {
      x -= FWindowWidth;
    }
    else if (!c && (extended == 'M')) {
      x += FWindowWidth;
    }
    else if (!c && (extended == 'G')) {
      x = 0;
    }
    else if (!c && (extended == 'O')) {
      x = FMapWidth - FWindowWidth;
    }
    else if (!c && (extended == 'H')) {
      y -= FWindowHeight;
    }
    else if (!c && (extended == 'P')) {
      y += FWindowHeight;
    }
    else if (!c && (extended == 'I')) {
      y = 0;
    }
    else if (!c && (extended == 'Q')) {
      y = FMapHeight - FWindowHeight;
    }

    if (x < 0) { x = 0; }
    if (x > FMapWidth - FWindowWidth) { x = FMapWidth - FWindowWidth; }
    if (y < 0) { y = 0; }
    if (y > FMapHeight - FWindowHeight) { y = FMapHeight - FWindowHeight; }
  }

  free(FMapScene);
  free(FZBuffer);

  asm {
    mov ax, 0x0003;
    int 0x10;
  }
  printf("Mega Man III level viewer by Frenkel, 23-Aug-2008.\n");
  return 0;
}